GELF_GETSYMINFO(3)

NAME
gelf_getsyminfo, gelf_update_syminfo - read and update symbol information

LIBRARY
libelf

SYNOPSIS
#include <gelf.h>
GElf_Syminfo *
gelf_getsyminfo(Elf_Data *data, int ndx, GElf_Syminfo *syminfo);
int
gelf_update_syminfo(Elf_Data *data, int ndx, GElf_Syminfo *syminfo);

DESCRIPTION
These convenience functions are used to retrieve and update class-dependent Elf32_Syminfo and Elf64_Syminfo records in an ELF object.

Argument data is an Elf_Data descriptor associated with a section of type SHT_SUNW_syminfo. Argument ndx is the index of the record being retrieved or updated. The class-independent GElf_Syminfo structure is described in gelf(3).

Function gelf_getsyminfo() retrieves class-dependent record at index ndx in data buffer data and copies it to the destination pointed to by argument syminfo after translation to class-independent form.

Function gelf_update_syminfo() converts the class-independent record pointed to by argument syminfo to class-dependent form, and writes it to the record at index ndx in the data buffer described by argument data.

RETURN VALUES
Function gelf_getsyminfo() returns the value of argument syminfo if successful, or NULL in case of an error. Function gelf_update_syminfo() returns a non-zero value if successful, or zero in case of an error.

ERRORS
These functions may fail with the following errors:

[ELF_E_ARGUMENT]
    Arguments data or syminfo were NULL.

[ELF_E_ARGUMENT]
    Argument ndx was less than zero or larger than the number of symbols in the data descriptor.

[ELF_E_ARGUMENT]
    Data descriptor data was not associated with a section containing symbol information.

SEE ALSO
elf(3), elf_getdata(3), elf_getscn(3), gelf(3), gelf_getsym(3), gelf_update_sym(3)